//kretsloppKontroll-master
//redFrik 2009 gnu gpl v2
//mirf and spi libraries by stefan engelke

#include <avr/io.h>
#include <util/delay.h>
#include "nRF24L01.h"
#include "spi.c"
#include "mirf.c"

#define FOSC 8000000
#define BAUD 38400
#define MYUBRR FOSC/16/BAUD-1

void USART_Init(unsigned int ubrr);
void USART_Transmit(unsigned char data);
unsigned char USART_Receive(void);
void USART_Flush(void);
uint8_t bufRead[mirf_PAYLOAD];						//data to read from slave

int main(void) {
	
	USART_Init(MYUBRR);
	
	//--mirf init
	mirf_init();
	_delay_ms(50);
	sei();
	mirf_config();
	uint8_t buf[5];
	buf[0]= 0b00000111;								//1mbps
	mirf_write_register(RF_SETUP, buf, 1);
	buf[0]= 22;
	buf[1]= 21;
	buf[2]= 22;
	buf[3]= 23;
	buf[4]= 24;
	mirf_set_RADDR(buf);							//rx address
	buf[0]= 12;
	buf[1]= 11;
	buf[2]= 12;
	buf[3]= 13;
	buf[4]= 14;
	mirf_set_TADDR(buf);							//tx address
	
	//--main loop
	uint8_t i;
	for(;;) {
		
		while(!mirf_data_ready());
		mirf_get_data(bufRead);
		USART_Transmit(0xfe);
		USART_Transmit(0xfe);
		USART_Transmit(0xfe);
		for(i= 0; i<mirf_PAYLOAD; i++) {
			USART_Transmit(bufRead[i]);
		}
		USART_Transmit(0xff);
	}
	return 0;
}
void USART_Init(unsigned int ubrr) {
	UBRR0H= (unsigned char)(ubrr>>8);
	UBRR0L= (unsigned char)ubrr;
	UCSR0B= (1<<RXEN0)|(1<<TXEN0);
	UCSR0C= (1<<USBS0)|(3<<UCSZ00);
}
void USART_Transmit(unsigned char data) {
	while(!(UCSR0A&(1<<UDRE0)));
	UDR0= data;
}
unsigned char USART_Receive(void) {
	while(!(UCSR0A&(1<<RXC0)));
	return UDR0;
}
void USART_Flush(void) {
	unsigned char dummy;
	while(UCSR0A&(1<<RXC0)) {
		dummy=UDR0;
	}
}
