//kretsloppKontroll-slave
//redFrik 2009 gnu gpl v2
//mirf and spi libraries by stefan engelke

#include <util/delay.h>
#include "nRF24L01.h"
#include "spi.c"
#include "mirf.c"

#define FOSC 1000000
#define mirf_PAYLOAD 1
#define master_payload 7

unsigned int adcVal;
uint8_t bufWrite[master_payload];					//data to send to master
uint8_t bufWriteLast[master_payload];				//copy of data to detect changes

int main(void) {
	PORTD= 0b00111000;								//pull-ups for switches
	
	//--adc init
	ADMUX |= (1<<REFS0);							//voltage reference
	ADCSRA |= ((1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0));	//prescaler 64
	ADCSRA |= (1<<ADEN);							//enable adc
	
	//--mirf init
	mirf_init();
	_delay_ms(50);
	sei();
	mirf_config();
	uint8_t buf[5];
	buf[0]= 0b00000111;								//1mbps
	mirf_write_register(RF_SETUP, buf, 1);
	buf[0]= 12;
	buf[1]= 11;
	buf[2]= 12;
	buf[3]= 13;
	buf[4]= 14;
	mirf_set_RADDR(buf);							//rx address
	buf[0]= 22;
	buf[1]= 21;
	buf[2]= 22;
	buf[3]= 23;
	buf[4]= 24;
	mirf_set_TADDR(buf);							//tx address
	
	//--main loop
	uint8_t i, flag;
	for(;;) {
		
		//--read data from controllers
		for(i= 0; i<6; i++) {						//read all 6 adc channels
			ADMUX &= ~0x0f;
			ADMUX |= i;								//set channel
			ADCSRA |= (1<<ADSC);					//start conversion
			while(bit_is_set(ADCSRA, ADSC));		//wait until conversion finished
			adcVal= ADCW;							//read 10bit value
			bufWrite[i]= adcVal>>2;					//scale down to 8bit
		}
		bufWrite[6]= PIND&0b00111000;				//read buttons
		
		//--check if any value changed
		flag= 0;
		for(i= 0; i<master_payload; i++) {
			if(bufWrite[i]!=bufWriteLast[i]) {
				flag= 1;
				bufWriteLast[i]= bufWrite[i];
			}
		}
		
		//--send if any value changed
		if(flag==1) {
			mirf_send(bufWrite, master_payload);
			_delay_ms(20);								//wait
		}
	}
	
	return 0;
}
